org.springframework.batch.core.listener

## Enum StepListenerMetaData

- java.lang.Object
- - java.lang.Enum<StepListenerMetaData>
  - - org.springframework.batch.core.listener.StepListenerMetaData

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<StepListenerMetaData>, ListenerMetaData

      public enum StepListenerMetaData
      extends java.lang.Enum<StepListenerMetaData>
      implements ListenerMetaData

  Enumeration for `StepListener` meta data, which ties together the names of methods, their interfaces, annotation, and expected arguments.
  Since:
    2.0
  Author:
    Lucas Ward
  See Also:
    `StepListenerFactoryBean`

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `AFTER_CHUNK`
    `AFTER_CHUNK_ERROR`
    `AFTER_PROCESS`
    `AFTER_READ`
    `AFTER_STEP`
    `AFTER_WRITE`
    `BEFORE_CHUNK`
    `BEFORE_PROCESS`
    `BEFORE_READ`
    `BEFORE_STEP`
    `BEFORE_WRITE`
    `ON_PROCESS_ERROR`
    `ON_READ_ERROR`
    `ON_SKIP_IN_PROCESS`
    `ON_SKIP_IN_READ`
    `ON_SKIP_IN_WRITE`
    `ON_WRITE_ERROR`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static StepListenerMetaData` | `fromPropertyName(java.lang.String propertyName)` Return the relevant meta data for the provided property name.
    `java.lang.Class<? extends java.lang.annotation.Annotation>` | `getAnnotation()`
    `java.lang.Class<?>` | `getListenerInterface()`
    `java.lang.String` | `getMethodName()`
    `java.lang.Class<?>[]` | `getParamTypes()`
    `java.lang.String` | `getPropertyName()`
    `static ListenerMetaData[]` | `itemListenerMetaData()`
    `static ListenerMetaData[]` | `stepExecutionListenerMetaData()`
    `static ListenerMetaData[]` | `taskletListenerMetaData()`
    `static StepListenerMetaData` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static StepListenerMetaData[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### BEFORE_STEP

          public static final StepListenerMetaData BEFORE_STEP

    - #### AFTER_STEP

          public static final StepListenerMetaData AFTER_STEP

    - #### BEFORE_CHUNK

          public static final StepListenerMetaData BEFORE_CHUNK

    - #### AFTER_CHUNK

          public static final StepListenerMetaData AFTER_CHUNK

    - #### AFTER_CHUNK_ERROR

          public static final StepListenerMetaData AFTER_CHUNK_ERROR

    - #### BEFORE_READ

          public static final StepListenerMetaData BEFORE_READ

    - #### AFTER_READ

          public static final StepListenerMetaData AFTER_READ

    - #### ON_READ_ERROR

          public static final StepListenerMetaData ON_READ_ERROR

    - #### BEFORE_PROCESS

          public static final StepListenerMetaData BEFORE_PROCESS

    - #### AFTER_PROCESS

          public static final StepListenerMetaData AFTER_PROCESS

    - #### ON_PROCESS_ERROR

          public static final StepListenerMetaData ON_PROCESS_ERROR

    - #### BEFORE_WRITE

          public static final StepListenerMetaData BEFORE_WRITE

    - #### AFTER_WRITE

          public static final StepListenerMetaData AFTER_WRITE

    - #### ON_WRITE_ERROR

          public static final StepListenerMetaData ON_WRITE_ERROR

    - #### ON_SKIP_IN_READ

          public static final StepListenerMetaData ON_SKIP_IN_READ

    - #### ON_SKIP_IN_PROCESS

          public static final StepListenerMetaData ON_SKIP_IN_PROCESS

    - #### ON_SKIP_IN_WRITE

          public static final StepListenerMetaData ON_SKIP_IN_WRITE

  - ### Method Detail

    - #### values

          public static StepListenerMetaData[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (StepListenerMetaData c : StepListenerMetaData.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static StepListenerMetaData valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### getMethodName

          public java.lang.String getMethodName()

      Specified by:
        `getMethodName` in interface `ListenerMetaData`

    - #### getAnnotation

          public java.lang.Class<? extends java.lang.annotation.Annotation> getAnnotation()

      Specified by:
        `getAnnotation` in interface `ListenerMetaData`

    - #### getListenerInterface

          public java.lang.Class<?> getListenerInterface()

      Specified by:
        `getListenerInterface` in interface `ListenerMetaData`

    - #### getParamTypes

          public java.lang.Class<?>[] getParamTypes()

      Specified by:
        `getParamTypes` in interface `ListenerMetaData`

    - #### getPropertyName

          public java.lang.String getPropertyName()

      Specified by:
        `getPropertyName` in interface `ListenerMetaData`

    - #### fromPropertyName

          public static StepListenerMetaData fromPropertyName(java.lang.String propertyName)

      Return the relevant meta data for the provided property name.
      Parameters:
        `propertyName` - property name to retrieve data for.
      Returns:
        meta data with supplied property name, null if none exists.

    - #### itemListenerMetaData

          public static ListenerMetaData[] itemListenerMetaData()

    - #### stepExecutionListenerMetaData

          public static ListenerMetaData[] stepExecutionListenerMetaData()

    - #### taskletListenerMetaData

          public static ListenerMetaData[] taskletListenerMetaData()